/* ---------------------------------------------------------------------------------
 * Redirection du shell
 * Jean-Paul Rigault 
 * ---------------------------------------------------------------------------------
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <wait.h>

/* Permissions par dfaut des fichiers crs : rw pour tous
 * (elles seront en plus filtres par le umask)
 */
#define USER_PERM (S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)

/* La commande  excuter, sous forme d'un tableau de mme type que argv  */
char *params[] = {
    "ls",		/* le nom de la commande */
    "ring.c",		/* un nom de fichier (existant dans ce rpertoire */
    "station.c",	/* idem */
    "foo",		/* un nom de fichier (inexistant dans ce rpertoire */
    "bar",		/* idem */
    NULL		/* indispensable */
};

int main()
{
    int fd;

    switch (fork()) 
    {
    case -1:
        perror("fork");
        exit(1);

    case 0: /* Le fils excute la commande */
        
        /* Auparavant il faut efffectuer les redirections */
        fd = open("out", O_WRONLY | O_CREAT | O_TRUNC, USER_PERM);
        if (fd < 0)
        {
            perror("open");
            exit(1);
        }
        dup2(fd, 1); 	/* redirection de la sortie standard */
        close(fd);	/* fd ne sert plus  rien maintenant */
        dup2(1, 2);	/* efffectue le 2>&1 : attention au sens ! */
        execvp("ls", params);
        perror("execvp");
        exit(1);

    default: /* Le pre attend */
 
        wait(0);
    }

    return 0;
}
        
